## cif2hkl 1.4.3+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.24)

#First a bit of magic to extract the version number from cif2hkl.F90, where we
#expect there will be a single line like >> VERSION="1.2.1"<< somewhere. This is
#a bit backwards from how one might do it in a purely cmake-based project, but
#hopefully it will be good enough for our purposes. One could also have used a
#command like >>git describe --tags --dirty --match "v[0-9]*"<< to extract it
#from the last git tag of the form "vx.y.z", however that would not work when
#the code was downloaded via an archive rather than git cloned. The present
#scheme should hopefully always make it compatible with what the installed
#"cif2hkl --version" will report.

set( cif2hkl_src_name "cif2hkl.F90" )
file( READ "${CMAKE_CURRENT_SOURCE_DIR}/${cif2hkl_src_name}" tmp )
string( REGEX REPLACE "\r?\n" ";" tmp "${tmp}" )
set( cif2hkl_extracted_version "" )
foreach( line ${tmp} )
  if ( line MATCHES "VERSION" )
    string(REGEX MATCH "^[ \\t]*VERSION[ \\t]*=[ \\t]*\"([0-9]*)\\.([0-9]*)\\.([0-9]*)\"" line "${line}")
    if ( line )
      set ( line "${CMAKE_MATCH_1}.${CMAKE_MATCH_2}.${CMAKE_MATCH_3}" )
      if ( line MATCHES "^[1-9][0-9]*\\.[0-9]+\\.[0-9]+$" )
        set( cif2hkl_extracted_version "${line}" )
        break()
      endif()
    endif()
  endif()
endforeach()
if ( NOT cif2hkl_extracted_version )# MATCHES "^[1-9][0-9]*\\.[0-9]+\\.[0-9]+$" )
  message(FATAL_ERROR "Could not extract version number from ${cif2hkl_src_name}")
endif()
message( STATUS "Extracted cif2hkl VERSION from ${cif2hkl_src_name}: ${cif2hkl_extracted_version}")

#Now declare the project:
project( cif2hkl VERSION ${cif2hkl_extracted_version} LANGUAGES Fortran )

#Pick installation directory below CMAKE_INSTALL_PREFIX in standard manner,
#allowing both the standard CMAKE_INSTALL_BINDIR and the project specific
#cif2hkl_BINDIR as means to override:
include( GNUInstallDirs )
if ( NOT cif2hkl_BINDIR )
  set( cif2hkl_BINDIR "${CMAKE_INSTALL_BINDIR}" )
endif()

#Now configure the build and installation of the cif2hkl executable:

file( GLOB CFMLSRC CONFIGURE_DEPENDS "${PROJECT_SOURCE_DIR}/CFML/*.f90" )
add_executable( cif2hkl "${PROJECT_SOURCE_DIR}/${cif2hkl_src_name}" ${CFMLSRC} )

#For each compiler flag, only add it if it is supported by the compiler, in the
#hope that this will make us slightly more portable:
include(CheckFortranCompilerFlag)
foreach( compilerflag -ffree-line-length-512 -lm )
  check_fortran_compiler_flag( "${compilerflag}" is_supported )
  if ( is_supported )
    target_compile_options( cif2hkl PRIVATE "${compilerflag}" )
  endif()
endforeach()

install( TARGETS cif2hkl DESTINATION "${cif2hkl_BINDIR}" )

#Tests (this makes a "test" target):

include(CTest)
add_test( NAME cif2hkl-get-version COMMAND cif2hkl --version )
file( GLOB EXAMPLE_TEST_FILES CONFIGURE_DEPENDS "${PROJECT_SOURCE_DIR}/examples/*.cfl"  "${PROJECT_SOURCE_DIR}/examples/*.cif" )
foreach( fn ${EXAMPLE_TEST_FILES} )
  get_filename_component( bn ${fn} NAME )
  add_test( NAME "cif2hkl-convert-${bn}" COMMAND cif2hkl --verbose --xtal --no-output-files "${fn}" )
endforeach()

=== Makefile ===
# Makefile to compile cif2hkl.
# required: gfortran
#
# just type: make; sudo make install

# simple one-shot compile
all:	
	${FC} -ffree-line-length-512 \
	CFML/CFML_GlobalDeps_Linux.f90 CFML/CFML_Math_General.f90 \
	CFML/CFML_String_Utilities_gf.f90   CFML/CFML_Math_3D.f90 \
	CFML/CFML_Symmetry_Tables.f90        CFML/CFML_Scattering_Chemical_Tables.f90 \
	CFML/CFML_Crystallographic_Symmetry.f90         CFML/CFML_Crystal_Metrics.f90 \
	CFML/CFML_Reflections_Utilities.f90      CFML/CFML_Atom_TypeDef.f90 \
	CFML/CFML_Geometry_Calc.f90        CFML/CFML_Molecular_Crystals.f90 \
	CFML/CFML_Diffraction_Patterns.f90         CFML/CFML_Magnetic_Groups.f90 \
	CFML/CFML_EisPack.f90          CFML/CFML_IO_Formats.f90 \
	CFML/CFML_Structure_Factors.f90 -o cif2hkl cif2hkl.F90 -lm $(FFLAGS) $(LDFLAGS) $(CPPFLAGS)
	rm *.mod

clean: 
	rm -f *.o *.mod cif2hkl

install:
	install -D cif2hkl \
		$(DESTDIR)$(prefix)/usr/bin/cif2hkl

distclean: clean

uninstall:
	-rm -f $(DESTDIR)$(prefix)/usr/bin/cif2hkl

test:
	./cif2hkl --version
	./cif2hkl --verbose --xtal --no-output-files examples/CaF2.cfl
	@echo Test OK
	
deb:
	debuild -b

.PHONY: all install clean distclean uninstall test deb

## cif2hkl 1.4.2+ds1

=== debian/changelog ===
cif2hkl (1.4.2+ds1-1) unstable; urgency=medium

  * Document copyright info for example datasets and CFML library.
  * Exclude LuMnO3.cif dataset (unclear license).
  * Generate manpage with help2man.
  * Initial upload (Closes: #1020400).

 -- Roland Mas <lolando@debian.org>  Wed, 28 Sep 2022 11:04:29 +0200

cif2hkl (1.4.1-1~0) unstable; urgency=medium

  * Switch to non-native packaging. Thanks, Emmanuel, for the previous work!
  * Packaging tweaks: build-depends, package description, copyright, use
    of dh_installexamples.

 -- Roland Mas <lolando@debian.org>  Tue, 20 Sep 2022 21:21:33 +0200

cif2hkl (1.4.1) unstable; urgency=medium

  * New upstream version 1.4.1 with updated CrysFML

 -- Emmanuel Farhi <emmanuel.farhi@synchrotron-soleil.fr>  Wed, 15 Jun 2022 09:47:49 +0100

cif2hkl (1.3) unstable; urgency=medium

  * New upstream version 1.3

 -- Emmanuel Farhi <emmanuel.farhi@synchrotron-soleil.fr>  Tue, 24 May 2022 16:49:54 +0100

=== debian/control ===
Source: cif2hkl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Emmanuel Farhi <emmanuel.farhi@synchrotron-soleil.fr>,
 Roland Mas <lolando@debian.org>
Build-Depends: debhelper-compat (= 13), fort77, gfortran, help2man
Standards-Version: 4.6.0
Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/cif2hkl

Package: cif2hkl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Convert crystallographic descriptions into HKL F^2 reflection lists
 A program that computes structure factors |F^2| for neutrons, x-rays,
 and electrons from CIF/CFL/SHX/PCR crystallographic descriptions.
 This is useful to compute the diffraction pattern from materials.
 .
 This package contains the executable.

=== debian/watch ===
version=4
opts=\
repack,repacksuffix=+ds1,dversionmangle=auto \
https://gitlab.com/soleil-data-treatment/soleil-software-projects/cif2hkl/-/tags?sort=updated_desc archive/v@ANY_VERSION@/cif2hkl-v?[\d.]+\S*@ARCHIVE_EXT@

## cif2hkl 1.4.3+ds1

=== debian/changelog ===
cif2hkl (1.4.3+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Tue, 10 Oct 2023 15:18:05 +0200

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build $@
	help2man --output=cif2hkl.1 --version-string=$$(dpkg-parsechangelog -S Version | sed -e s/-[^-]*$$// -e s/[+].*//) --no-discard-stderr --no-info --name=cif2hkl ./cif2hkl

## cif2hkl 1.4.5+ds1

=== debian/changelog ===
cif2hkl (1.4.5+ds1-2) unstable; urgency=medium

  * Team upload.
  * Add Vcs-Browser: & Vcs-Git: tags.

 -- Alexandre Detiste <tchet@debian.org>  Fri, 07 Feb 2025 12:13:38 +0100

cif2hkl (1.4.5+ds1-1) unstable; urgency=medium

  * d/watch: only the git interface is stable...
  * New upstream version 1.4.5+ds1

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 25 Nov 2024 13:14:29 +0100

## cif2hkl 1.4.6+ds1

=== debian/changelog ===
cif2hkl (1.4.6+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 1.4.6+ds1

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Fri, 14 Feb 2025 20:06:25 +0100

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,8 @@
 Build-Depends: debhelper-compat (= 13), fort77, gfortran, help2man
 Standards-Version: 4.6.0
 Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/cif2hkl
+Vcs-Browser: https://salsa.debian.org/science-team/cif2hkl
+Vcs-Git: https://salsa.debian.org/science-team/cif2hkl.git
 
 Package: cif2hkl
 Architecture: any

=== debian/watch ===
version=4
opts=\
"repack,repacksuffix=+ds1,dversionmangle=auto,mode=git" \
  https://gitlab.com/soleil-data-treatment/soleil-software-projects/cif2hkl.git \
  refs/tags/@ANY_VERSION@

## cif2hkl 1.4.7+ds1

=== Makefile ===
--- 
+++ 
@@ -17,17 +17,32 @@
 	CFML/CFML_Structure_Factors.f90 -o cif2hkl cif2hkl.F90 -lm $(FFLAGS) $(LDFLAGS) $(CPPFLAGS)
 	rm *.mod
 
+help:
+	@help2man --output=man/cif2hkl.1 --version-string=1.4.7 --no-discard-stderr --no-info --name="compute diffraction structure factors" ./cif2hkl || echo "WARNING: failed to generate man page"
+	@pandoc README.md --to pdf > man/README.pdf || echo "WARNING: skip pdf doc (missing pandoc)"
+	@echo "Usage: install cif2hkl"
+	@echo "make all"
+	@echo "  compile"
+	@echo "make install"
+	@echo "  install cif2hkl"
+	@echo "make deb"
+	@echo "  create debian package"
+
 clean: 
 	rm -f *.o *.mod cif2hkl
 
 install:
-	install -D cif2hkl \
-		$(DESTDIR)$(prefix)/usr/bin/cif2hkl
+	install -D cif2hkl $(DESTDIR)$(prefix)/usr/bin/cif2hkl
+	install -D man/cif2hkl.1 $(DESTDIR)$(prefix)/usr/share/man/man1/cif2hkl.1
+	install -D -d $(DESTDIR)$(prefix)/usr/share/doc/cif2hkl
+	install -D man/README.pdf $(DESTDIR)$(prefix)/usr/share/doc/cif2hkl
 
 distclean: clean
 
 uninstall:
 	-rm -f $(DESTDIR)$(prefix)/usr/bin/cif2hkl
+	-rm -f $(DESTDIR)$(prefix)/usr/share/man/man1/cif2hkl.*
+	-rm -fr $(DESTDIR)$(prefix)/usr/share/doc/cif2hkl
 
 test:
 	./cif2hkl --version
@@ -35,7 +50,10 @@
 	@echo Test OK
 	
 deb:
-	debuild -b
+	rm -rf debian
+	cp -r packaging/debian .
+	debuild -b || true
+	rm -rf debian
 
 .PHONY: all install clean distclean uninstall test deb

=== debian/changelog ===
cif2hkl (1.4.7+ds1-1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Tue, 03 Feb 2026 22:22:06 +0100

cif2hkl (1.4.7+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 1.4.7+ds1
  * d/patch: removed as this is now in the upstream 

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Tue, 13 May 2025 15:35:34 +0200
